#include "e0main.h"
#include "e0physics.cpp"


//Determines the length of a vector drawn between two 3D points
GLfloat determine3ddistance(GLfloat x1, GLfloat y1, GLfloat z1, GLfloat x2, GLfloat y2, GLfloat z2){
	GLfloat t2ddist;
	t2ddist=sqrt(((x2-x1)*(x2-x1))+((z2-z1)*(z2-z1)));
	return sqrt((t2ddist*t2ddist)+((y2-y1)*(y2-y1)));
}


void monstertype::facepoint(GLfloat nx, GLfloat ny, GLfloat nz){
	GLfloat xdist, ydist, zdist;
	GLfloat pxdist, pydist, pzdist;
	GLfloat nxd;
	GLfloat tdist;
	GLfloat t3ddist;

	ny-=MonsterInfoArray[type].camheight;
	
	xdist=nx-x;
	zdist=nz-z;
	ydist=ny-y;
	tdist=sqrt((xdist*xdist)+(zdist*zdist));
	t3ddist=sqrt((tdist*tdist)+(ydist*ydist));
	pxdist=xdist/tdist;
	pzdist=zdist/tdist;
	
	//Ugh. Must find a better way of doing this.
	if(pxdist<0.0f)
		td=(-(acos(-pzdist)/degrees));
	else
		td=((acos(-pzdist)/degrees));

	xdir=td;
	//Ditto
	if(ydist>0.0f)
		ydir=(asin((tdist/t3ddist))/degrees)-90.0f;
	else
		ydir=-(asin((tdist/t3ddist))/degrees)+90.0f;
}
void shottype::turntopoint(GLfloat nx, GLfloat ny, GLfloat nz){
	GLfloat xdist, ydist, zdist;
	GLfloat pxdist, pydist, pzdist;
	GLfloat tdist, td, nxd;
	GLfloat t3ddist;
	bool goinpos;

	xdist=nx-x;
	zdist=nz-z;
	ydist=ny-y;
	tdist=sqrt((xdist*xdist)+(zdist*zdist));
	t3ddist=sqrt((tdist*tdist)+(ydist*ydist));
	pxdist=xdist/tdist;
	pzdist=zdist/tdist;
	
	if(pxdist<0.0f)
		td=(-(acos(-pzdist)/degrees));
	else
		td=((acos(-pzdist)/degrees));

	if(td<0)
		td+=360.0f;
	if(td>=180){
		if(xdir>td || (xdir>=0&&xdir<=td-180))
			goinpos=false;
		else
			goinpos=true;
	}else{
		if(xdir>td&&xdir<td+180)
			goinpos=false;
		else
			goinpos=true;
	}

	if(goinpos)
		xdir+=ShotInfoArray[type].turnspeed;
	else
		xdir-=ShotInfoArray[type].turnspeed;
	
	
	if(ydist>0.0f)
		ydir=(asin((tdist/t3ddist))/degrees)-90.0f;
	else
		ydir=-(asin((tdist/t3ddist))/degrees)+90.0f;

	zs=-(cos(xdir*radians)*cos(ydir*radians))*ShotInfoArray[type].speed;
	ys=-sin(ydir*radians)*ShotInfoArray[type].speed;
	xs= (sin(xdir*radians)*cos(ydir*radians))*ShotInfoArray[type].speed;
	
	if(xdir>360.0f)
		xdir-=360.0f;
	if(xdir<0.0f)
		xdir+=360.0f;
}

void monstertype::turntopoint(GLfloat nx, GLfloat ny, GLfloat nz){
	GLfloat xdist, ydist, zdist;
	GLfloat pxdist, pydist, pzdist;
	GLfloat nxd;
	GLfloat tdist;
	GLfloat t3ddist;
	bool goinpos;

	ny-=MonsterInfoArray[type].camheight;
	
	xdist=nx-x;
	zdist=nz-z;
	ydist=ny-y;
	tdist=sqrt((xdist*xdist)+(zdist*zdist));
	t3ddist=sqrt((tdist*tdist)+(ydist*ydist));
	pxdist=xdist/tdist;
	pzdist=zdist/tdist;
	
	if(pxdist<0.0f)
		td=(-(acos(-pzdist)/degrees));
	else
		td=((acos(-pzdist)/degrees));

	if(td<0)
		td+=360.0f;
	if(td>=180){
		if(xdir>td || (xdir>=0&&xdir<=td-180))
			goinpos=false;
		else
			goinpos=true;
	}else{
		if(xdir>td&&xdir<td+180)
			goinpos=false;
		else
			goinpos=true;
	}

	if(goinpos)
		xdir+=MonsterInfoArray[type].ta;
	else
		xdir-=MonsterInfoArray[type].ta;
	
	
	if(ydist>0.0f)
		ydir=(asin((tdist/t3ddist))/degrees)-90.0f;
	else
		ydir=-(asin((tdist/t3ddist))/degrees)+90.0f;
}
void monstertype::findnewtarget(void){
	
	
	
	
	return;
}

void monstertype::walkfowards(void){
	if(MonsterInfoArray[type].flying){
		x+=sin(xdir*radians)*cos(ydir*radians)*MonsterInfoArray[type].a;
		z-=cos(xdir*radians)*cos(ydir*radians)*MonsterInfoArray[type].a;
		y-=sin(ydir*radians)*MonsterInfoArray[type].a;
	}else{
		x+=sin(xdir*radians)*MonsterInfoArray[type].a;
		z-=cos(xdir*radians)*MonsterInfoArray[type].a;
	}
}

void DoAI(GLvoid){
	//return;
	int mi,i2;
	int targ; GLfloat dist;
	for(mi=0;mi<MonsterArraySize;mi++){
		targ=-1;
		dist=20.0f;
		if(MonsterInfoArray[MonsterArray[mi].type].friendly){
			for(i2=0;i2<MonsterArraySize;i2++){
				if(!MonsterInfoArray[MonsterArray[i2].type].friendly && determine3ddistance(MonsterArray[mi].x,MonsterArray[mi].y,MonsterArray[mi].z,MonsterArray[i2].x,MonsterArray[i2].y,MonsterArray[i2].z)<dist){
					targ=i2;
					dist=determine3ddistance(MonsterArray[mi].x,MonsterArray[mi].y,MonsterArray[mi].z,MonsterArray[i2].x,MonsterArray[i2].y,MonsterArray[i2].z);
				}
			}
		}else{
			for(i2=0;i2<MonsterArraySize;i2++){
				if(MonsterInfoArray[MonsterArray[i2].type].friendly && determine3ddistance(MonsterArray[mi].x,MonsterArray[mi].y,MonsterArray[mi].z,MonsterArray[i2].x,MonsterArray[i2].y,MonsterArray[i2].z)<dist){
					targ=i2;
					dist=determine3ddistance(MonsterArray[mi].x,MonsterArray[mi].y,MonsterArray[mi].z,MonsterArray[i2].x,MonsterArray[i2].y,MonsterArray[i2].z);
				}
			}
		}
		MonsterArray[mi].target=targ;
		if(determine3ddistance(MonsterArray[mi].x,MonsterArray[mi].y+(MonsterInfoArray[MonsterArray[mi].type].height/2.0f),MonsterArray[mi].z,Player.x,Player.y+(MonsterInfoArray[Player.type].height/2.0f),Player.z)<PrefsViewDistance)
			MonsterArray[mi].visible = true;
		else
			MonsterArray[mi].visible = false;
		
		if(MonsterArray[mi].target>-1 && MonsterInfoArray[MonsterArray[mi].type].aitype==1 && determine3ddistance(MonsterArray[mi].x,MonsterArray[mi].y+(MonsterInfoArray[MonsterArray[mi].type].height/2.0f),MonsterArray[mi].z,Player.x,Player.y+(MonsterInfoArray[Player.type].height/2.0f),Player.z)<10.0f){
			//If we're near the player and target...
			if(rand()%2000>=1000){
				if(determine3ddistance(MonsterArray[mi].x,MonsterArray[mi].y+(MonsterInfoArray[MonsterArray[mi].type].height/2.0f),MonsterArray[mi].z,MonsterArray[MonsterArray[mi].target].x,MonsterArray[MonsterArray[mi].target].y+(MonsterInfoArray[MonsterArray[MonsterArray[mi].target].type].height/2.0f),MonsterArray[MonsterArray[mi].target].z)<MonsterInfoArray[MonsterArray[mi].type].range1&&MonsterArray[mi].shotdelay<=0){
					if(MonsterArray[mi].curaction!=4)
						MonsterArray[mi].turntopoint(MonsterArray[MonsterArray[mi].target].x, MonsterArray[MonsterArray[mi].target].y+(MonsterInfoArray[MonsterArray[MonsterArray[mi].target].type].height/2.0f), MonsterArray[MonsterArray[mi].target].z);
					if(MonsterArray[mi].curaction==0 || MonsterArray[mi].curaction==1){
						//Attack!!
						if(MonsterInfoArray[MonsterArray[mi].type].hesitation1==0||rand()%MonsterInfoArray[MonsterArray[mi].type].hesitation1==1){
							MonsterArray[mi].frame=1;
							MonsterArray[mi].frametimer=0;
							MonsterArray[mi].curaction=2;
							MonsterArray[mi].repsleft=WeaponInfoArray[MonsterInfoArray[MonsterArray[mi].type].weapon1].reps;
							if(MonsterArray[mi].repsleft<=0)
								MonsterArray[mi].repsleft=1;
						}else
							MonsterArray[mi].shotdelay=WeaponInfoArray[MonsterInfoArray[MonsterArray[mi].type].weapon1].rate;
					}
				}
			}else{
				if(determine3ddistance(MonsterArray[mi].x,MonsterArray[mi].y+(MonsterInfoArray[MonsterArray[mi].type].height/2.0f),MonsterArray[mi].z,MonsterArray[MonsterArray[mi].target].x,MonsterArray[MonsterArray[mi].target].y+(MonsterInfoArray[MonsterArray[MonsterArray[mi].target].type].height/2.0f),MonsterArray[MonsterArray[mi].target].z)<MonsterInfoArray[MonsterArray[mi].type].range2&&MonsterArray[mi].shotdelay2<=0){
					if(MonsterArray[mi].curaction!=4)
						MonsterArray[mi].turntopoint(MonsterArray[MonsterArray[mi].target].x, MonsterArray[MonsterArray[mi].target].y+(MonsterInfoArray[MonsterArray[MonsterArray[mi].target].type].height/2.0f), MonsterArray[MonsterArray[mi].target].z);
					if(MonsterArray[mi].curaction==0 || MonsterArray[mi].curaction==1){
						//Attack!!
						if(MonsterInfoArray[MonsterArray[mi].type].hesitation2==0||rand()%MonsterInfoArray[MonsterArray[mi].type].hesitation2==1){
							MonsterArray[mi].frame=1;
							MonsterArray[mi].frametimer=0;
							MonsterArray[mi].curaction=5;
							MonsterArray[mi].repsleft=WeaponInfoArray[MonsterInfoArray[MonsterArray[mi].type].weapon2].reps;
							if(MonsterArray[mi].repsleft<=0)
								MonsterArray[mi].repsleft=1;
						}else
							MonsterArray[mi].shotdelay2=WeaponInfoArray[MonsterInfoArray[MonsterArray[mi].type].weapon2].rate;
					}
				}
			}
			switch(MonsterArray[mi].curaction){
			case 0:		//Standing
				//temp
				MonsterArray[mi].curaction=1;
				MonsterArray[mi].cursequence=MonsterInfoArray[MonsterArray[mi].type].sequence[1];
				//
				break;
			case 1:		//Walking
					MonsterArray[mi].turntopoint(MonsterArray[MonsterArray[mi].target].x, MonsterArray[MonsterArray[mi].target].y+(MonsterInfoArray[MonsterArray[MonsterArray[mi].target].type].height/2.0f), MonsterArray[MonsterArray[mi].target].z);
					MonsterArray[mi].walkfowards();
					MonsterArray[mi].cursequence=MonsterInfoArray[MonsterArray[mi].type].sequence[2];
				break;
			case 2:		//Shooting (Weapon 1)
				if(SequenceArray[MonsterArray[mi].cursequence].criticalframe==MonsterArray[mi].frame&&MonsterArray[mi].frametimer<=speedfactor*PrefsFramesSkipFactor){
					if(MonsterArray[mi].repsleft>0){
						MonsterArray[mi].shoot(mi,MonsterInfoArray[MonsterArray[mi].type].weapon1,false);
						MonsterArray[mi].frametimer=0.0f;
						MonsterArray[mi].repsleft--;
					}
				}
				MonsterArray[mi].cursequence=MonsterInfoArray[MonsterArray[mi].type].sequence[3];
				break;
			case 3:		//Flinching
				MonsterArray[mi].cursequence=MonsterInfoArray[MonsterArray[mi].type].sequence[6];
				break;
			case 4:		//Soft Dying
				MonsterArray[mi].cursequence=MonsterInfoArray[MonsterArray[mi].type].sequence[7];
				break;
			case 5:		//Shooting (Weapon 2)
				if(SequenceArray[MonsterArray[mi].cursequence].criticalframe==MonsterArray[mi].frame&&MonsterArray[mi].frametimer<=speedfactor*PrefsFramesSkipFactor){
					if(MonsterArray[mi].repsleft>0){
						MonsterArray[mi].shoot(mi,MonsterInfoArray[MonsterArray[mi].type].weapon2,true);
						MonsterArray[mi].frametimer=0.0f;
						MonsterArray[mi].repsleft--;
					}
				}
				MonsterArray[mi].cursequence=MonsterInfoArray[MonsterArray[mi].type].sequence[8];
				break;
			}
			
		}
	}
	return;
}