/*
Engine/Zero
Copyright (C) 2006  Lewis Hosie

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/






///////////////
//ENG1NE/ZER0//
///////////////

#include "e0main.h"
#include "fonts.h"
#include "e0ai.cpp"
#include "e0interface.cpp"
#include "e0graphics.cpp"
#include "e0physics.cpp"
#include "e0files.cpp"
#include "e0sounds.cpp"
#include "e0network.cpp"

/////////////////////






bool	active=true;		// Window Active Flag Set To TRUE By Default
bool	fullscreen=false;	// Yes, windowed mode sucks.



//For finding FPS count
GLint T0     = 0;
GLint Frames = 0;

//Temp data and loop integers
int i, i2;
float gf;
//I shouldn't make these global... but it's just so much easier

int inputmode;								//Input mode. 0 == local. 1 == demo. 2 == network.
float colorarray[4][3][2];				//Color array for selections, interface, etc
				//RGBA/ColorNo(Selection=0,Background=1)/Normal(0) vs Target(1)
bool pulsecolor[2];

//Misc data
bool	keys[256];						// Array used for the keyboard routines

int currentscreen = 0, subscreen = 0;	// Holds the screen/subscreen we're at 
float pulsetimer;

//Level definitons

mediatype MediaArray[200];
int MediaArraySize;


weaponinfotype WeaponInfoArray[300];
int WeaponInfoArraySize=6;

monsterinfotype MonsterInfoArray[250];
int MonsterInfoArraySize=250;

flashtype FlashArray[FlashArraySize];



//For graphics (beams) - Don't be fooled, this does NOT
//mean you can only have one beam onscreen at once.
float hitpointx, hitpointy, hitpointz;

						//You'd be *amazed* how quickly you can go
particletype ParticleArray[ParticleArraySize+1];	//through 5000 particles...
particleinfotype ParticleInfoArray[ParticleInfoArraySize+1];

monstertype MonsterArray[1000];
int MonsterArraySize=1;

polyt PolygonArray[10000];					//The Holy Polygon Array
int PolygonArraySize=1;					//And it's size definition

linet LineArray[10000];							//The Line Array.
int LineArraySize=1;							//And it's size definition

texture *TextureArray;			//The texture array holds texture info
int TextureArraySize=1;

GLuint StaticTextures[32];


GLuint *BitmapArray;			//Whereas the bitmap array hold the actual graphics
int BitmapArraySize=50;
int CustomBitmapArraySize=0;

Mix_Music *TheMusic = NULL;

soundtype *SoundArray;
int SoundArraySize=1;

lighttype LightArray[150];
int LightArraySize=1;

itemtype ItemInfoArray[250];
int ItemInfoArraySize=1;

itemtype ItemArray[250];
int ItemArraySize=1;

shottype ShotArray[MaxShotArraySize];
int ShotArraySize=2;

sequencetype SequenceArray[1000];
int SequenceArraySize;

shotinfotype ShotInfoArray[1000];
int ShotInfoArraySize=1000;

solidtype SolidArray[SolidArraySize];

bool TagArray[500];				//Yep. FIVE HUNDRED TAGS. Got to wonder who would use them...
bool InterLevelTagArray[100];	//...
int InterLevelIntArray[100];

platformtype *PlatformArray;
int PlatformArraySize;

char PlayerName[255] = "Playa";
int PlayerInventory[500];
int WeaponAmmo[100];
int PlayerPriSelection;
int PlayerSecSelection;
int PlayerSelection=1;

char ScenarioName[255];
char ScenarioGraphicsType[255];
char CurrentSong[255];

pointtype ModelPointArray[50][1500];
pointtype ModelNormalArray[50][500];
facetype ModelPolyArray[50][1500];
edgetype ModelEdgeArray[50][1500];

//float radians

SDL_CD *cdrom;		//Used to access music from a CD

int FlashMode;
int FlashFadeSpeed;

int ShotNo=1;     //which screenshot we're up to

bool XRayVision=false;	
bool NightVision=false;
bool ScanVision=false;
bool Zooming=false;
float ZoomAmount = 3.0f;

////////////////////////////////////////////////

char	TermText[255];
int		TermEditPoint=-1;

char	ObjectiveList[32][255];
bool	ObjectiveComplete[32];
bool	ShowObjectives;
int		ObjectiveLink[32];
int		NoOfObjectives;


// For displaying
/*int		PolyList[500];
int		PolyListSize;
int		PolyDepth[500];*/
int		Trans;

char	ScenarioDir[255]="Scenario1";

//Level info variables
int		CurrentLevel=1;
char	LevelName[255];				//Level info - author
char	LevelAuthor[255];				//Level info - author
char	LevelDateCompleted[255];		//Level info - date completed
char	LevelComments[255];			//Level info - author's comments
float TheLight[]= { 5.0f, 5.0f, 5.0f, 1.0f };
int		PolysToVisit[32];
int		LastVisit=1;

bool	LButtonDown;
bool	MButtonDown;
bool	RButtonDown;

//Controls
bool			PrefsInterpolateMouse = false;		//Smooths mouse motions, giving an effect some people love and other hate.
bool			PrefsInvertMouse = false;			//Flips mouse on Y axis
bool			PrefsUseMouse = true;				//Using the mouse at all?

//Preference variables

int				PrefsBeltSize = 16;			//How big is the on-screen inventory 'belt'?
float			PrefsMaxBeltTrans = 1.0f;		//Usual Belt Transparency Factor
float			PrefsBeltTrans = PrefsMaxBeltTrans;		//Belt Transparency Factor
bool			PrefsHideBelt=false;
bool			PrefsMinimalInterface=true;


float			PrefsTermTrans = 1.0f;		//Term Transparency Factor
//Stupid (Don't touch these)

//Crosshair
float 		PrefsCrosshairHeight = 0.05f;		//Pref - Crosshair Height
float 		PrefsCrosshairWidth = 0.05f;		//Pref - Crosshair Width
int 			PrefsCrosshairThickness = 1;		//Pref - Crosshair Thickness

//Graphics
bool			PrefsMipMapping = true;				//MIPmapping enabled?
bool			PrefsParticleFX = true;				//Particles enabled?
bool			PrefsFarLinearFiltering = true;		//Pref - Linear or nearest filtering for distant objects?
bool			PrefsNearLinearFiltering = true;	//Pref - Linear or nearest filtering for close objects?
bool			PrefsBetterPerspective = true;		//Pref - Use Nicest perspective correction?
//bool			PrefsAdditiveAlpha = true;			//Pref - What mode of transparency? Now rarely set to additive
int bitdepth = 32, screenwidth = 1024, screenheight = 768;
//bool			PrefsE0Lighting = true;				//Pref - New or Marathon style lighting?
bool			Prefs3rdPerson = false;				//3rd person view?
bool			PrefsShowFPS = false;				//Count the frames per second?
bool			PrefsCompensativeSpeed = false;		//Constant speed? (Only enable if PrefsFrameSkipFactor is 1)
bool			Prefs3DMap = false;					//3D Map?
bool			PrefsShowPosition = false;			//
float			PrefsViewDistance=60.0f;

int				PrefsFramesSkipFactor=3;			//Frame skipping factor ( 1 is normal, increase to cut load times but make animations look worse)
int				PrefsGameDelay = 6;				//Controls game speed
bool			PrefsNostalgiaMode = false;			//Even us programmers need a laugh sometimes...
bool			PrefsText = true;

//Noise
bool			PrefsCDMusic = false;				//Play music from a CD if available?

//Control
float 		PrefsMouseSens=0.3f;

// The SDL surface
SDL_Surface *surface;

float speedfactor=1.0f;
long int noofframes;
int landscapeno = 1;
bool	isloaded;











//////////////////////////PROGRAM!

//Cleans up afterwards
void Quit(int returnCode){
	Mix_HaltMusic();
	Mix_HaltChannel(-1);	//Test this!
	Mix_FreeMusic(TheMusic);
	TheMusic = NULL;
	
	Mix_CloseAudio();		//Close the audio device
    SDL_Quit( );			//Kill the window
	KillFont();				//Kill the Bitmap font

	//Stop playing the bloody CD!!
	if(PrefsCDMusic){
		SDL_CDStop(cdrom);
		//Close the CD access handle
		SDL_CDClose(cdrom);
	}

    exit(returnCode);
}

//Reset the viewport
int resizeWindow(int width, int height){
    //Height:width ratio
    float ratio = ( float )width / ( float )height;
    glViewport( 0, 0, ( GLint )width, ( GLint )height );	//Set up the viewport
    glMatrixMode( GL_PROJECTION );							//Switch to projection matrix
    glLoadIdentity( );
    gluPerspective( 45.0f, ratio, 0.1f, PrefsViewDistance );			//Set the perspective
    glMatrixMode( GL_MODELVIEW );							//Switch back to model matrix
    glLoadIdentity( );										//Reset the view... again...
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );	//Clear the screen
    glFlush();												//Do this or risk green!!
	return( TRUE );
}


//Handle key presses
void handleKeyPress(SDL_keysym *keysym){
    switch ( keysym->sym )
	{
	case SDLK_ESCAPE:
	    //They pressed escape; quit. Remove/change this when ready...
	    Quit( 0 );
	    break;
	default:
		keys[keysym->sym]=true;	//Register the keypress
	    break;
	}

    return;
}
//Handle key releases
void handleKeyRelease(SDL_keysym *keysym){
	keys[keysym->sym]=false;
    return;
}

//Main function
int main( int argc, char **argv ){
    int videoFlags;			//Flags to pass to SDL_SetVideoMode
    int done = FALSE;		//Main loop variable
    SDL_Event event;		//Used to collect events
    const SDL_VideoInfo *videoInfo;  //This holds some info about our display
    int isActive = TRUE;	//Are we doing... anything?
	int i;

	for(i=1;i<argc;i++){
		sscanf(argv[i],"level%i",&CurrentLevel);
	}

	LoadPrefs();			//Fwaf
	
	if(PrefsNostalgiaMode==true)
		PrefsFramesSkipFactor=13;

    //initialize SDL
    if ( SDL_Init( SDL_INIT_VIDEO | SDL_INIT_AUDIO | SDL_INIT_CDROM) < 0 ){
	    fprintf( stderr, "Initialization failed: %s\n",
		SDL_GetError( ) );
	    Quit( 1 );
	}
	SetupSounds();
	SDL_ShowCursor(SDL_DISABLE);
    videoInfo = SDL_GetVideoInfo( );	//Find out about the video info
    if ( !videoInfo ){
	    fprintf( stderr, "Video query failed: %s\n",
		SDL_GetError( ) );
	    Quit( 1 );
	}
    //The flags to pass to SDL_SetVideoMode:
    videoFlags  = SDL_OPENGL;				//Enable OpenGL. Set to SDL_OPENGLBLIT if trying to take screenshots. Will be slower, though.
    videoFlags |= SDL_GL_DOUBLEBUFFER;		//Enable double buffering
    videoFlags |= SDL_HWPALETTE;			//Store the palette in hardware
    //Do we have to save the buffer into memory? If so, it sucks.
    if ( videoInfo->hw_available )
		videoFlags |= SDL_HWSURFACE;
    else
		videoFlags |= SDL_SWSURFACE;
    //Are hardware blits available?
    if ( videoInfo->blit_hw )
		videoFlags |= SDL_HWACCEL;
	if(fullscreen)
		videoFlags |= SDL_FULLSCREEN;
    //Set up OpenGL double buffering
    SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );
    //Get an SDL surface
	surface = SDL_SetVideoMode( screenwidth, screenheight, bitdepth,
				videoFlags );
    //Make sure the surface actually exists
    if ( !surface ){
	    fprintf( stderr,  "Video mode set failed: %s\nCheck the requested video mode is supported by your graphics card.", SDL_GetError( ) );
	    Quit( 1 );
	}
    //initialize OpenGL
    if ( initGL( ) == FALSE ){
	    fprintf( stderr, "Could not initialize OpenGL.\n" );
	    Quit( 1 );

	}
	SDL_WM_SetCaption("Engine Zero","E0");
	BuildFont();
	GameInit(); //Init game now
	//Resize the initial window
    resizeWindow( screenwidth, screenheight );
	
    //Wait for an event
    while ( !done ){
	    //Handle the events in the queue
	    while ( SDL_PollEvent( &event ) ){
		    switch( event.type ){
			case SDL_ACTIVEEVENT:
			    //Something's happend with our focus
			    //	If we lost focus or we are iconified, we
			    //	shouldn't draw the screen, or indeed
				// do anything else.
			    if ( event.active.gain == 0 )
				isActive = FALSE;
			    else
				isActive = TRUE;
			    break;
			case SDL_VIDEORESIZE:
				//Doing this COMPLETELY fucks OpenGL for some reason.
			    //Handle the resize
			    surface = SDL_SetVideoMode( event.resize.w,
							event.resize.h,
							bitdepth, videoFlags );
			    if ( !surface )
				{
				    fprintf( stderr, "Could not get a surface after resize: %s\n", SDL_GetError( ) );
				    Quit( 1 );
				}
			    resizeWindow( event.resize.w, event.resize.h );
			    break;
			case SDL_KEYDOWN:
			    handleKeyPress( &event.key.keysym );
			    break;
			case SDL_KEYUP:
				handleKeyRelease( &event.key.keysym );
			    break;
			//case SDL_MOUSEMOTION:
				//How about NO?!
			case SDL_MOUSEBUTTONDOWN:
			case SDL_MOUSEBUTTONUP:		//Do the same thing...
				LButtonDown=SDL_GetMouseState(NULL, NULL)&SDL_BUTTON(1);
				MButtonDown=SDL_GetMouseState(NULL, NULL)&SDL_BUTTON(2);
				RButtonDown=SDL_GetMouseState(NULL, NULL)&SDL_BUTTON(3);
				break;
			case SDL_QUIT:
			    // handle quit requests
			    done = TRUE;
			    break;
			default:
			    break;
			}
		}
		pulsetimer+=speedfactor;
	    //Do all that stuff
		if(currentscreen==0){
			DoLoadingScreen();
			SDL_GL_SwapBuffers();
		}else{
			if(isActive){
				switch(currentscreen){
				case(3):
					DoColors();
					DoMenus();
					break;
				case(1):
					if(SDL_GetTicks() >= noofframes+PrefsGameDelay||SDL_GetTicks()+128 < noofframes){
						noofframes=SDL_GetTicks();
						DoColors();
						DoAI();
						DoInput();
						DoPhysics();
						DoSounds();
						DoAnimations();
						DrawGLScene();					// Draw The Scene
						// Draw it all to the screen 
						DoNetwork();
						SDL_GL_SwapBuffers();
					}
					break;
				}
			}
		}
	}
    //Clean up and quit
    Quit( 0 );
    //Should never get here, but this prevents MSVC complaining.
    return( 0 );
}

//Initialises the game and loads stuff from files
int GameInit(GLvoid){          //Woo! Yeah! Let's all init the physics and all that here!
	LoadScenario(1);
	BuildStaticTextures();
	
	PreprocessASound(1);
	for(i=0;i<SoundArraySize;i++)
		SoundArray[i].NoOfAlts=0;
	LoadSequences(1);
	LoadPhysics(CurrentLevel);
	//Important: Order MUST be presound-loadphys-preprocess-validate-loadtex-loadmap
	//This is because of custom textures...
	//Changing the order REALLY fucks things up

	PreprocessTexture(1);
	ValidateMap(CurrentLevel);
	

	Player.polyparent=1;
	Player.ydir=0.0f;
	Player.type=0;

	// Play the entire CD
	if(PrefsCDMusic){
		cdrom=SDL_CDOpen(0);
		if(cdrom)
			if(CD_INDRIVE(SDL_CDStatus(cdrom)))
				SDL_CDPlayTracks(cdrom, 0, 0, 0, 0);
	}
	return TRUE;
}





int SaveGame(char filepath[]){
	
	
	return 0;
}





// Think I am l33+? If so WH4t h@V3 j00 Be3N 5mOKIN9 DuDe? 1 M34n R3@lLy i+ W0Uld H4v3 tO 83 Pr3+TY w1Ld TO m4K3 J00 th1nK 1 @M e133t! I SuX0rz! h4ha pwn3d luZ0r5 gG
//If Jesus came back right now, wouldn't a cross be the LAST thing he'd want to see?
//Future projects of mine: another (faster) engine, an Elite like game, a Deus Ex ish game, and numerous other things